
markup.push({

    
RecordingSpinner:
{
    nsClass: "GXDrawView",
    gxHideOnNilValue: true,
    gxAnimationDivider: 2,
    gxForePainter: "RecordingSpinnerPainter",
	gxTransition: {
		nsClass: "GXSpinnerTransition",
		gxDuration: 1.0,
		gxRunOn: 1.0,
	},
},

RecordingSpinnerPainter:   // caar painter!
{
    nsClass: "GXCaarPainter",
    gxDuration: 1.0,
	gxAsset: "stopped",
	gxTintColor: "ForeColor2.noLightMode",
	lightMode: {
		ready: {
			gxTintColor: "ColorTheme1.dimmed",
			gxAsset: "ready",
			gxEdgeInsets: "2, 2, 2, 2",
		},
	},
	ready: {
		gxTintColor: "ColorTheme1",
		gxAsset: "ready",
		gxEdgeInsets: "2, 2, 2, 2",
	},
	running: {
		gxTintColor: "ColorLive1",
		gxAsset: "running",
		gxAssetDuration: 2.0,
		gxLoopStart: 1.0,
		gxPlaybackSpeed: 0.75,
    },
    recording: {
        gxTintColor: "RecordingColor",
		gxAsset: "recording",
		gxAssetDuration: 2.0,
		gxLoopStart: 1.0,
		gxPlaybackSpeed: 0.5,
    },
    broadcasting: {
        gxTintColor: "ColorLive1",
		gxAsset: "broadcasting",
		gxAssetDuration: 2.0,
		gxLoopStart: 1.0,
		gxPlaybackSpeed: 0.75,
    },
    gxHAlign: 0.5,
    gxVAlign: 0.5,
},

    
// MARK: audio file view

// one for each recording
RecordedFileView:
{
	nsClass: "GXListItem",
	gxFrameRect: "10, 80, 294, 60",
    gxViewName: "audioFile",   
	gxViewModel: {
		nsClass: "AH4AudioFileViewModel",
		gxSharedViewModelID: "AudioFileViewModel"
	},
	gxSelectable: 2, // multiselect
	gxMenuItemsKeyPath: "contextMenuItems",
	gxIntrinsicWidth: 294,
	gxIntrinsicHeight: 60,
	axIsIgnored: false,
	axRoleDescription: "Recorded File",
	axTitleKeyPath: "displayName",
	axDescriptionKeyPath: "accessibilityDescription",
	axHelp: "VO press to open an Inspector window",
	gxBackPainter: {
		"+": "ListItemBack",
		gxCornerRadius: 8,
	},
	gxLateLayout:
	[
		"H:|-10-[self(294)]",
//		"V:[self(60)]",
//
//		"H:|-0-[title]-8-|",
//		"V:|-7-[title(20)]-5-[fileTime]",
//
//		"H:|-8-[spinner(21)]-5-[recordingFormat]",
//		"V:[title]-2-[spinner(21)]",
//
//		"H:[recordingFormat(110)]-8-[fileSize]-8-[fileTime(50)]-0-|&alignBaseline",
//
//		"H:|-7-[playBtn(17)]-5-[waveForm]-0-[fileTime]&alignCenterY",
//		"V:[waveForm(28)]",
	],
	gxChildViews:
	{
		spinnerHost:
		{
			nsClass: "GXLayerHostingView",
			gxFrameRect: "8, 30, 21, 21",
			gxShowOnKey: "isRecording",
			gxRootLayer:
			{
				nsClass: "GXCaarLayer",
				gxViewName: "spinner",
				gxAnimateOnKey: "isRecording",
				gxShowOnKey: "isRecording",
				gxAnimationDivider: 2,
				gxCaarPainter: "RecordingSpinnerPainter",
				gxTransition: {
					nsClass: "GXSpinnerTransition",
					gxDuration: 1.0,
					gxRunOn: 1.0,
				},
			}
		},
		title: {
			"+": "LabelView.top",
			gxFrameRect: "0, 7, 286, 20",
			gxValueKey: "displayName",
            axTitle: "File Title",
			gxForePainter:
			{
				"+": "LabelFore.foreColor1.left.size13.mediumWeight",
				gxEdgeInsets: "10, 0, 10, 0",
			},
		},
        fileSize: {
            "+": "LabelView.centerx.colorThemeLive1.size12",
			gxFrameRect: "152, 32, 84, 17",
            gxValueKey: "fileSize",
            gxAnimateOnKey: "isRecording",
            gxShowOnKey: "isRecording",
            axTitle: "File Size",
            gxFormatter: { nsClass: "PTFileSizeFormatter" }
        },
		fileTime: {
			"+": "LabelView.centerx.colorThemeLive1.size12",
			gxFrameRect: "244, 32, 50, 17",
			gxValueKey: "fileTime",
			gxAnimateOnKey: "isRecording",
            axIsIgnored: false,
            axTitle: "File Duration",
			gxFormatter: { nsClass: "PTTrackTimeFormatter" }
		},
		recordingFormat: {
			"+": "LabelView.left.mediumWeight.colorThemeLive1.size13",
			gxFrameRect: "34, 32, 110, 17",
			gxShowOnKey: "isRecording",
			gxToolTipKeyPath: "fullDescription"
		},
		playBtn: {
			nsClass: "GXButtonView",
			gxFrameRect: "7, 30, 17, 22",
			gxBackPainter: "ImagePainter.foreColor1.playbtn",
			gxValueKey: "filePlayBtn",
			gxLayerZPosition: 10,
            gxButtonType: "toggle",
			axTitle: "play or pause",
			gxDisableOnKey: "isRecording",
		},
		waveForm: {
            nsClass: "GXWaveView",
			gxFrameRect: "29, 27,  215, 28",
			gxValueKey: "playPosition",
            gxActiveWhenSelected: true,
			gxAnimateOnKey: "isPlaying",
			gxOnlyLoadWhenVisible: true,
//            gxLayout: [
//                "H:|-0-[fullWave]-0-|",
//                "V:|-0-[fullWave]-0-|",
//
//                "H:[playhead(2)]",
//                "V:|-0-[playhead]-0-|",
//            ],
            gxRootLayer:
            {
                nsClass: "GXDrawLayer",
                gxLayerZPosition: 2,
                gxSublayers:
                {
                    fullWave: {
                        nsClass: "GXWaveLayer",
                        gxLayerZPosition: 4,
                        gxValueKey: "waveData",
						gxFrameRect: "0, 0, 215, 28",
                        gxNeedsDisplayOnResize: true,
                        gxPainter: {    // only provides colors
                            nsClass: "GXPainter",
                            gxFillColor: "ForeColor1",
                        },
                    },
                    playhead: {
                        // playhead is a puppet created for GXWaveView to use
                        nsClass: "GXDrawLayer",
						gxFrameRect: "0, 0, 2, 28",
                        gxLayerZPosition: 10,
                        gxBackPainter: {    // only used for colors
                            nsClass: "GXPainter",
                            gxCornerRadius: 1,
                            gxBackColor: "ColorThemeLive1",
                            //selected: { gxBackColor: "ForeColor2", }
                        },
                    },
                }
            }
		},
	}
},


})
