
markup.push({

	// --------------------------------------------------------
	// MARK: - preferences window

	PreferencesEditorDropView: {		// referenced in Prefs window .xib
		nsClass: "GXDropView",
		gxCornerRadius: 2,
		strokeWidth: 2,
		gxStrokeColor: "name:dropHilite",
		acceptDroppedApps: true,
		gxValueKey: "droppedApp"
	},

	ImageView: {
		nsClass: "GXDrawView",
		gxForePainter: "ImagePainter",
		gxIntrinsicHeight: 16,
		gxIntrinsicWidth: 16,
	},

	InfoIcon: {
		nsClass: "GXDrawView",
		gxForePainter: "ImagePainter.foreColor2.info-icon",
		gxIntrinsicHeight: 16,
		gxIntrinsicWidth: 16,
	},


	// -------------------------------------------------
	// MARK: popup menu template

	PopupMenuTemplate: {
		"+": "PopupMenuView",
		gxLabelTemplate: "LabelView.right.size13",
		gxHideOnNilValue: true
	},

	// -------------------------------------------------
	// MARK: checkbox template

	CheckboxTemplate:
    {
		nsClass: "GXButtonView",
		//gxIconBaseName: "checkbox",
        gxButtonType: "checkbox",
        gxForePainter: "CheckBoxFore",
		gxIntrinsicHeight: 23,
		gxBaselineOffset: 6,
		gxLabelTemplate: "LabelView.right.size13"
	},

	CheckBoxFore:
    {
		"+": "ControlFore.useMarkup.left",
        on: {
            // nothing - needed to avoid title color change of button
        }
	},

	
	// -------------------------------------------------
	// MARK: checkbox template

	PlusButton: {
		"+": "ButtonView",
		gxForePainter: "CheckBoxFore",
		gxBackPainter: null,
		gxTitle: "<plusButton/>",
	},
	
	MinusButton: {
		"+": "ButtonView",
		gxForePainter: "CheckBoxFore",
		gxBackPainter: null,
		gxTitle: "<minusButton/>",
		gxDisableOnNil: true,
	},

	// -------------------------------------------------
	// MARK: textfield templates

	ReadoutTextField: {
		nsClass: "GXNumberField",
		gxTextPainter: "ReadoutTextPainter",
		gxBackPainter: "ReadoutBg",
		gxIntrinsicHeight: 16,
		gxDisabledAlphaColor: colorMono(0, 28),
		gxInsertionPointColor: "WhiteColor",
		gxSelectionColor: "TextSelectionColor",
		gxDrawFocusRing: false,
	},

	ReadoutTextPainter: {
		"+": "LabelFore",
		gxBackColor: "BackColor2" // textfield's own fill color, should match painter fill
	},

	ReadoutBg: {
		nsClass: "GXPainter",
		gxCornerRadius: 3,
		editing: {
			gxFrameColor: "BackColor2",
		}
	},

	
	// -------------------------------------------------
	// MARK: textfield readout template

	TextPainter:
	{
		nsClass: "GXStringPainter",
		gxFontSize: 13,
		gxFontColor: "ForeColor1",
		gxBackColor: "BackColor3",
		gxHAlign: 0
	},

	BaseTextField:
	{
		nsClass: "GXTextField",
		gxIntrinsicHeight: 25,
		gxBaselineOffset: 7,
		gxTextPainter: "TextPainter",
		gxInsertionPointColor: "ForeColor1",
		gxSelectionColor: "TextSelectionColor",
	},

	DarkTextField:
	{
		"+": "BaseTextField",
		gxEdgeInsets: "2, 5, 2, 3",	// insets for text within the field's bounds.
									// which changes baseline offset, etc
		gxBackPainter: "ControlBack",
		gxPlaceholderStyle: "PlaceholderStyle.disabled",
		gxLabelTemplate: "LabelView.right.size13",
	},

	PlaceholderStyle:
	{
		nsClass: "GXStyledString",
		gxFontSize: 13,
		gxFontColor: "ForeColor1",
	},
	

	// MARK: token field template

	TokenField:
	{
		"+": "DarkTextField",
		nsClass: "GXTokenField",
		gxTokenTemplate: "TextTokenAttachment",
		gxButtonBackPainter:
		{
			nsClass: "GXPainter",
			gxCornerRadii: "0, 8, 8, 0",
			gxEdgeInsets: "0, 1, 1, 1",
			gxFillColor: "BackColor2",
		},
		gxButtonForePainter:
		{
			"+": "ImagePainter.token-menu",
			gxDefaultSize: "24, 22",	// required, sets button size
			gxEdgeInsets: "0, 2, 0, 0",
			gxTintColor: "ColorTheme1",
		},
	},

	TextTokenAttachment:
	{
		gxDefaultSize: "20, 15",	// token size. height always used, width used as minumum
		gxBaselineOffset: -3,
		gxForePainter: {
			"+": "ControlFore",
			gxFontSize: 11.5,
			gxAlignment: "0.5, 0.5",
			gxEdgeInsets: "6,1,6,1",
			gxFontColor: "ForeColorTheme2"
		},
		gxBackPainter: {
			nsClass: "GXPainter",
			gxCornerRadius: 999,
			gxEdgeInsets: "1,1,1,0",
			//gxFrameColor: "ColorTheme2",
			gxFillColor: "ColorTheme1",
		},
	},

	// MARK: album art template

	ArtView: {
		nsClass: "GXArtView",
		gxBackPainter: "ControlBack",
		gxForePainter: "ArtViewFore",
		gxStrokeColor: "TextSelectionColor",	// for drag drop hilite
		gxDisabledAlphaColor: "BackColor3",
		noDefaultText: {
			gxForePainter: "",
		},
	},

	ArtViewFore: {
		"+": "ControlFore",
		gxLineBreakMode: 0,	// word wrap
		gxAlignment: "0.5, 0.5",
		gxFontColor: "ForeColor2",
		gxFontSize: 10,
		gxDefaultString: "Drag\n Artwork\n Here",
	},

	


})
