


markup.push({

	
	// --------------------------------------------------------
	// MARK: library bits

	LibraryChildList:
	{
		nsClass: "GXStackView",
        gxDefaultValue: true, // expanded!
        axIsIgnored: true,
		gxBackPainter: fillPainter("SidebarBackColor2"),
		gxIntrinsicWidth: 276,
	},

	
	LibraryDisclosureButton:
	{
		"+": "ButtonView",
		gxDisableOnNil: false,
        axHelp: "Expand or collapse a section of library blocks",
		axRoleDescription: "Disclosure Button",
		gxLayout:
		[
			"H:|-0-[self]-0-|",
			"V:[self(33)]"
		],
		gxBackPainter:
		{
			nsClass: "GXPainter",
			gxEdgeInsets: "0, 1, 0, 1",
			gxFillColor: "SidebarBackColor2",
		},
		gxForePainter:
		{
			"+": "LabelFore.useMarkup.mediumWeight.foreColor1.size135.left",
			gxEdgeInsets: "11, 6, 0, 4",
		},
		gxIntrinsicHeight: 33,
	},


	// --------------------------------------------------------
	// MARK: library list view

	LibraryRootList:
	{
		nsClass: "GXStackView",
		gxViewName: "libraryView",
        gxDefaultValue: true, // expanded!
		gxIntrinsicWidth: 276,
		axIsIgnored: true,
		gxChildViews :
		[
            {
                "+": "LibraryDisclosureButton",
                gxTitle: "<disclosure/> Sources",
				axFormatter: disclosureAxFormatter("Sources"),
                gxValueKey: "uiState.librarySourcesExpanded",
            },
			{
				"+": "LibraryChildList",
				gxValueKey: "uiState.librarySourcesExpanded",
				gxChildViews:
				[
					{ nsClass: "GELibraryBlockView", "+":"ApplicationSourceBlock" },
					{ nsClass: "GELibraryBlockView", "+":"AudioDeviceInputBlock" },
					{ nsClass: "GELibraryBlockView", "+":"SystemAudioBlock" },
				]
			},
            {
                "+": "LibraryDisclosureButton",
                gxTitle: "<disclosure/> Outputs",
				axFormatter: disclosureAxFormatter("Outputs"),
                gxValueKey: "uiState.libraryOutputsExpanded",
            },
			{
				"+": "LibraryChildList",
				gxValueKey: "uiState.libraryOutputsExpanded",
				gxChildViews:
				[
					{ nsClass: "GELibraryBlockView", "+":"AudioDeviceOutputBlock" },
					{ nsClass: "GELibraryBlockView", "+":"AudioRecorderBlock" },
					{ nsClass: "GELibraryBlockView", "+":"RTMPBlock" },
					{ nsClass: "GELibraryBlockView", "+":"BroadcastBlock" },
				]
			},
            {
                "+": "LibraryDisclosureButton",
                gxTitle: "<disclosure/> Built-In Effects",
				axFormatter: disclosureAxFormatter("Built-In Effects"),
                gxValueKey: "uiState.libraryEffectsExpanded",
            },
			{
				"+": "LibraryChildList",
				gxValueKey: "uiState.libraryEffectsExpanded",
				gxChildViews:
				[
					{ nsClass: "GELibraryBlockView", "+":"Equalizer10Block" },
					{ nsClass: "GELibraryBlockView", "+":"ParametricEQBlock", h4PreReleaseBlock: true },
					{ nsClass: "GELibraryBlockView", "+":"BalanceBlock" },
					{ nsClass: "GELibraryBlockView", "+":"BassTrebleBlock" },
					{ nsClass: "GELibraryBlockView", "+":"ChannelTweakerBlock" },
					{ nsClass: "GELibraryBlockView", "+":"LowPassFilterBlock" },
					{ nsClass: "GELibraryBlockView", "+":"MagicBoostBlock" },
					{ nsClass: "GELibraryBlockView", "+":"MonoEnhancerBlock" },
					{ nsClass: "GELibraryBlockView", "+":"PanBlock" },
					{ nsClass: "GELibraryBlockView", "+":"SimpleCompressorBlock" },
					{ nsClass: "GELibraryBlockView", "+":"GainEffectsBlock" },
				]
			},
            {
                "+": "LibraryDisclosureButton",
                gxTitle: "<disclosure/> Meters",
				axFormatter: disclosureAxFormatter("Meters"),
                gxValueKey: "uiState.libraryMetersExpanded",
            },
			{
				"+": "LibraryChildList",
				gxValueKey: "uiState.libraryMetersExpanded",
				gxChildViews :
				[
					{ nsClass: "GELibraryBlockView", "+":"LevelMeterBlock" },
					{ nsClass: "GELibraryBlockView", "+":"VUMeterBlock" },
				]
			},
            {
                "+": "LibraryDisclosureButton",
                gxTitle: "<disclosure/> Advanced",
				axFormatter: disclosureAxFormatter("Advanced"),
                gxValueKey: "uiState.libraryAdvancedExpanded",
            },
			{
				"+": "LibraryChildList",
				gxValueKey: "uiState.libraryAdvancedExpanded",
				gxChildViews:
				[
					{ nsClass: "GELibraryBlockView", "+":"RNNoiseFilterBlock", h4PreReleaseBlock: true  },
					{ nsClass: "GELibraryBlockView", "+":"DeclickBlock" },
					{ nsClass: "GELibraryBlockView", "+":"DehumBlock" },
					{ nsClass: "GELibraryBlockView", "+":"DenoiseBlock" },
					{ nsClass: "GELibraryBlockView", "+":"DuckingBlock" },
					{ nsClass: "GELibraryBlockView", "+":"FIRFilterBlock", h4PreReleaseBlock: true },
					{ nsClass: "GELibraryBlockView", "+":"InputToggleBlock" },
					{ nsClass: "GELibraryBlockView", "+":"MixerBlock" },
					{ nsClass: "GELibraryBlockView", "+":"SyncBlock" },
					{ nsClass: "GELibraryBlockView", "+":"TimeShiftBlock" },
				]
			},
            {
                "+": "LibraryDisclosureButton",
                gxTitle: "<disclosure/> Audio Unit Effects",
				axFormatter: disclosureAxFormatter("Audio Unit Effects"),
                gxValueKey: "uiState.libraryAudioUnitsExpanded",
            },
			{
				"+": "LibraryChildList",
				gxValueKey: "uiState.libraryAudioUnitsExpanded",
				gxViewName: "audioUnitsListView",	// named so code can find it
				gxChildViews:
				[
                    // code adds AU library blocks
				]
			}
		]
	},

	// --------------------------------------------------------
	// MARK: library drag view

	LibraryDragView:
	{
		nsClass: "GXDrawView",
		gxViewShadow: "{0, 0, 0, 0.4}, {0, 1}, 2.5",
		gxLayout:
		[
		 	"H:[self(50)]",
		 	"V:[self(50)]",
		],
		gxBackPainter:
		{
			nsClass: "GXPainter",
			gxEdgeInsets: "4, 4, 4, 4",
			gxCornerRadius: 8.5,
			gxStrokeWidth: 3,
			gxFillColor: "ColorTheme1",
			gxFrameColor: "SelectionColor2",
		},
		gxForePainter:
		{
			nsClass: "GXImagePainter",
			gxAlignment: "0.5, 0.5",
		},
	},

})
