
markup.push({


	// -------------------------------------------------
	// MARK: channel tweaker

FIRFilterBlock:
{
	"+": "BlockTemplate",
	gxTitle: "FIR Filter",
	axTitle: "F I R Filter",
	geNodeClass: "GEFIRFilterNode",
	h4PresetsId: "FIRFilterPresets",
	gxPopoverInfo: "FIRFilterPopover",
	gxIconPainter: "ImagePainter.block.effect.generic",
	gxLibraryIcon: "library.effect.generic",
	gxLibraryDescription: "Finite Impulse Response Filter",
},
	
	// MARK: menu items
	
	// MARK: popover

FIRFilterPopover:
{
	"+": "PopoverTemplate",
	gxTitle: "FIR Filter",
	gxCanDrawSubviewsIntoLayer: true,
	gxLayout: [ "H:|-12-[self(384)]-12-|",	// sets popover width
				"V:|-12-[self]-12-|",
				"V:|-41-[impulse][advancedBtn]-0-[advanced]-8-[presetsGroup]"
	],
	gxChildViews:
	{
		title: "PopoverTitle",
		switch: "PopoverOnOffSwitch",
		presetsGroup: presetsGroup(),
		impulse: {
			"+": "GroupView",
			gxLayout: [
				"H:|-0-[self]-0-|",
				"H:|-12-[groupTitle]-12-|",					   
				"H:|-12-[fileLabel(80)]-8-[file][loupe(20)]-8-|",
				"H:|-12-[resolutionLabel(80)]-8-[resolution]-8-|",
				"H:|-12-[lengthLabel(80)]-8-[length]-8-|",
				"H:|-12-[rateLabel(80)]-8-[rate]-8-|",
				"H:|-12-[grpdlyLabel(80)]-8-[grpdly]-8-|",
				"H:|-12-[totaldlyLabel(80)]-8-[totaldly(>=80)]-8-|",
				"V:|-36-[file]",
				"V:|-34-[loupe]",
				"V:|-36-[fileLabel]-8-[resolutionLabel]-8-[lengthLabel]-8-[rateLabel]-8-[grpdlyLabel]-8-[totaldlyLabel]-12-|",
				"V:|-36-[file]-8-[resolution]-8-[length]-8-[rate]-8-[grpdly]-8-[totaldly]-12-|",
			],
			gxChildViews: {
			groupTitle: groupTitleView("Impulse Response"),
			fileLabel: labelView("File:"),
			file: {
				"+": "LabelView.left",
				gxValueKey: "node.fileName",
			},
			resolutionLabel: labelView("Resolution:"),
			resolution: {
				"+": "LabelView.left",
				gxValueKey: "node.resolutionString",
			},
		lengthLabel: labelView("Length:"),
			length: {
				"+": "LabelView.left",
				gxValueKey: "node.lengthString",
			},
			rateLabel: labelView("Sample Rate:"),
			rate: {
				"+": "LabelView.left",
				gxValueKey: "node.rateString",
			},
			grpdlyLabel: labelView("Group Delay:"),
			grpdly: {
				"+": "LabelView.left",
				gxValueKey: "node.groupDelayString",
			},
			totaldlyLabel: labelView("Actual Delay:"),
			totaldly : {
				"+": "LabelView.left",
				gxValueKey: "node.totalDelayString",
			},
			loupe: {
				"+": "ImageButtonView.loupe",
				gxValueKey: "node.loupeBtn",
				axTitle: "Load Impulse Response",
				gxDisableOnKey: "running",
			},
			},
		},
		advancedBtn: {
			"+": "AdvancedGroupButton",
			gxTitle: "<disclosure/> Advanced",
			gxValueKey: "uiState.advancedExpanded",
			axFormatter: disclosureAxFormatter("Advanced"),
		},
		advanced: {
			"+": "ExpandingGroupView.noTopStroke",
			gxValueKey: "uiState.advancedExpanded",
			axIsIgnored: false,
			axTitle: "Advanced",
			gxCollapsible: true,
			gxCollapsedSize: 1,	// lets bottom stroke show
			gxExtraSize: 12,
			gxLayout: [
					   "H:|-0-[self]-0-|",
					   "H:|-[math64bitLabel(80)]-[math64bit]-24-|&alignBaseline",
					   "H:|-[threadLimitLabel(80)]-[threadLimit]-24-|&alignBaseline",
					   "H:|-[misrateLabel(80)]-[misrate]-24-|&alignBaseline",
					   "V:|-8-[math64bit]-8-[threadLimit]-8-[misrate]",
			],
			gxChildViews: {
			math64bitLabel: labelView(""),
			math64bit: {
				"+": "CheckboxTemplate",
				gxTitle: "<checkbox/> 64-bit Math Processing",
				gxValueKey: "node.math64bitProcessing",
				gxDisableOnKey: "running"
			},
			threadLimitLabel: labelView("Threads:"),
			threadLimit : {
				"+": "PopupMenuTemplate",
				gxValueKey: "node.threadLimitProcessing",
				gxMenuItemsKeyPath: "node.threadLimitMenuItems",
				gxDisableOnKey: "running",
			},
			misrateLabel: labelView("Misrate Fix:"),
			misrate : {
				"+": "PopupMenuTemplate",
				gxValueKey: "node.mismatchHandlingMode",
				gxMenuItemsKeyPath: "node.rateMismatchMenuItems",
				gxDisableOnKey: "running",
			}
			},
		},
	},
},
	
	// MARK: images

	// MARK: descriptions

})

