
markup.push(
{

// MARK: home window

HomeWindow:
{
	nsClass: "GXWindow",
	gxWindowTitle: "Audio Hijack Session List",
	gxCanFullScreen: true,
	gxWindowMaxSize: "1000, 2000",
	gxWindowMinSize: "700, 510",
	gxInitialWindowSize: "790, 540",
	gxInitialWindowPosition: "0.5, 0.22",
	gxBackColor: "BackColor2",
	gxSavedWindowStateKey: "homeWindow",
	gxContentView: "HomeWindowContentView",
    gxFullSizeContentView: true,
},


// MARK: content view

HomeWindowContentView:
{
	nsClass: "GXDrawView",
	gxViewModel: { nsClass: "AH4HomeViewModel" },
    gxBackPainter: fillPainter("SidebarBackColor2"),
	gxWantsLayer: true,
	gxLayout:
	[
		"V:[titleBarView(26)]-8-[headings(31)]-0-[sessionsScrollView]-0-[trialBar]-0-[bottomBar(45)]-0-|",
	 	"V:[headings]-1-[windowDropView]-1-[trialBar]",
		"V:[titleBarView]-1-[emptyView]-1-[trialBar]",

		"H:|-0-[headings]-0-|",
		"H:|-0-[sessionsScrollView]-0-|",
		"H:|-0-[windowDropView]-0-|",
		"H:|-0-[emptyView]-0-|",
		"H:|-0-[trialBar]-0-|",
	],
	gxChildViews:
	{
		titleBarView:
		{
			"+": "TitleBarView",
            gxBackPainter:
            {
                nsClass: "GXPainter",
                gxFillColor: "SidebarBackColor2",
                gxFrameColor: "BackColor3",
                gxEdgeInsets: "-1, -1, -1, 0",
            },
			gxChildViews:
			{
				windowTitle: {
					"+": "WindowTitle",
					gxDefaultValue: "Audio Hijack Session List",
				},
			},
		},
		headings: {
			"+": "SessionListHeadings",
		},
		windowDropView: {
			nsClass: "GXDropView",
			gxCornerRadius: 3,
			strokeWidth: 2,
			gxStrokeColor: "name:dropHilite",
			acceptDroppedSessions: true,
			gxValueKey: "droppedFiles",
			gxLayerZPosition: 10,
		},
		emptyView: {
			"+": "EmptyHomeView",
		},
		sessionsScrollView: {
			nsClass: "GXScrollView",
			gxBackColor: "SidebarBackColor2",
			gxVScrollbar: "ScrollBarView",	// vertical scroller only
			gxAddViewBelow: true,
			gxDocumentView:
            {
                nsClass: "GXListView",
                gxViewName: "sessionsList",
                gxLayout: "H:|-0-[self]-0-|",
                axIsIgnored: false,
				axTitle: "Sessions",
				axHelp: "List of all sessions",
                axRoleDescription: "list",
			}
		},
        trialBar: {
            "+": "TrialBarView",
            gxViewModel: { nsClass: "AH4TrialBarViewModel" },
        },
		bottomBar: {
			nsClass: "GXDrawView",
			gxBackPainter: "BottomBarBack",
			gxLayerZPosition: 10,
			gxLayout: [
				"H:|-0-[self]-0-|",
				"H:|-14-[newSessionBtn(108)]-(>=14)-[deleteBtn(24)]-14-|&alignBaseline",
				"H:[self]-(<=0)-[newSessionBtn]&alignCenterY",	// center vertically
				
				"V:[self]-0-[voiceOverInfoBtn(2)]&alignCenterX",
				"H:[voiceOverInfoBtn(1)]",
			],
			gxChildViews: {
				newSessionBtn: {
					"+": "PlusButton",
					gxTitle: "<plusButton/> New Session",
					axDescription: "New session",
					gxValueKey: "showTemplatesBtn",
				},
				deleteBtn: {
					"+": "MinusButton",
					gxValueKey: "deleteBtn",
					gxDisableOnNil: true,
					axDescription: "Delete selected sessions",
				},
				voiceOverInfoBtn: {
					"+": "ButtonView",
					gxTitle: "Voice Over Help",
					axTitle: "Voice Over Help",
					axHelp: "VO press to open a Knowledge Base article for Voice Over users in your web browser",
					gxValueKey: "voiceOverInfoBtn",
				},
			}
		}
	}
},


// --------------------------------------------------------
// MARK: - session list items

ListItemBack:
{
    nsClass: "GXPainter",
    gxFillColor: "SidebarBackColor1",
	//gxFrameColor: "BackColor3",
	gxStrokeWidth: 1,
    selected: {
        gxFillColor: "SelectionColor3",
        altRow: { }, // stop altRow resetting fill color
    },
    altRow: {
        gxFillColor: "SidebarBackColor2",
    }
},

SessionListItem:
{
	nsClass: "GXListItem",
    gxViewName: "sessionItem",
        
//    gxViewModel: {
//        nsClass: "AH4SessionViewModel",
//        gxSharedViewModelID: "SessionViewModel",
//    },
			
	gxSelectable: 2,
	gxIntrinsicHeight: 44,
	axRoleDescription: "Session",
    axTitleKeyPath: "accessibilityDescription",
    axHelp: "VO press to open the session window. Interact for more controls.",
	gxBackPainter: "ListItemBack",
    gxLateLayout:
    [
        "H:|-0-[self]-0-|",
		"H:|-12-[title(>=40)]-8-[sources(78)]-20-[autoRun(78)]-8-[homeStatus(100)]-7-[spinnerHost(21)]-7-[meterHostView(89)]-12-[runBtn(60)]-12-|",
		"V:|-10-[title(23)]",
		"V:|-9-[sources(27)]",
	 	"V:|-11-[autoRun(23)]",
		"V:|-3-[homeStatus(40)]",
        "V:|-13-[spinnerHost(21)]",
		"V:|-6-[meterHostView(36)]",
		"V:|-11-[runBtn(22)]",
	],
	gxChildViews:
	{
		title: {
			"+": "LabelView.foreColor1.size15.mediumWeight.left",
            gxIntrinsicWidth: -1,
			gxValueKey: "name",
            axTitle: "Session Title",
            axIsIgnored: false,
		},
		sources: {
			"+": "LabelView.foreColor1.clip.useMarkup.left.size14",
			gxValueKey: "graph.graphSources",
		},
		autoRun: {
			"+": "PopupMenuTemplate",
			gxValueKey: "autoStart",
			axTitle: "Auto Run",
            gxMenuItems:
            [
                menuItem("Off", 0),
                menuItem("On Launch", 1, "", "Launch"),
                //menuItem("At Login", 2, "", "Login"),
            ],
		},
		homeStatus: {
			"+": "LabelView.useMarkup.showAnimating.centery.right",
			gxAnimateOnKey: "animateStatusText",
            axTitle: "Status",
            axIsIgnored: false,
		},
        spinnerHost: {
            nsClass: "GXLayerHostingView",
            gxRootLayer:
            {
                nsClass: "GXCaarLayer",
                gxViewName: "spinner",
                gxAnimateOnKey: "running",
                gxHideOnNilValue: true,
                gxAnimationDivider: 2,
                gxCaarPainter: "RecordingSpinnerPainter",
            }
        },
        meterHostView: {
            nsClass: "GXLayerHostingView",
            gxLayerZPosition: 2,
            gxRootLayer:
            {
                nsClass: "AH4SpecMeterLayer",
                gxValueKey: "specMeterNarrowData",
                gxAnimateOnKey: "graph.started",
                gxForePainter: {
                    nsClass: "GXPainter",
                    gxFillColor: "ColorThemeLive2",
                },
            }
        },
		runBtn: {
			"+": "RunButton.size13",
		},
	}
},

// --------------------------------------------------------
// MARK: session list headings

SessionListHeadings:
{
	nsClass: "GXDrawView",
	gxBackPainter: fillPainter("SidebarBackColor2"),
    axIsIgnored: true,
    axDescription: "Session list column headings",
	gxLayout: [
		"V:|-0-[name]",
		"H:|-12-[name]-6-[sources(90)]-8-[autoRun(78)]-4-[status(100)]-224-|&alignBaseline",
	],
	gxChildViews:
	{
        name: {
            "+": "LabelView.left.thinWeight",
            gxIntrinsicWidth: -1,
            gxDefaultValue: "Name",
        },
		sources: labelView("Sources", "left.thinWeight"),
		autoRun: labelView("Auto Run", "left.thinWeight"),
		status: labelView("Status", "right.thinWeight"),
	}
},


// --------------------------------------------------------
// MARK: - finalize on quit

QuitFinalizingSheet:
{
	nsClass: "GXWindow",
	gxContentView: {
		nsClass: "GXDrawView",
		gxBackPainter: "QuitFinalizingSheetBack",
		gxLayout: [
			"H:|-0-[self(530)]-0-|",	// this determines window width
			"V:|-16-[title(20)]-8-[information(34)]-16-|",	// this determines sheet height
			"H:|-30-[title]-30-|",
			"H:|-30-[information]-30-|"
		],
		gxChildViews: {
			title: {
				"+": "LabelView.mediumWeight.size15",
				gxDefaultValue: "Audio Hijack is finalizing your recording",
				gxIntrinsicWidth: -1
			},
			information: {
				"+": "LabelView.left.top.size12.wrap",
				gxDefaultValue: "AAC and ALAC (.m4a) recordings are unplayable until necessary post-processing finishes. Audio Hijack will quit automatically once finalization is complete.",
				gxIntrinsicWidth: -1
			}
		}
	}
},

QuitFinalizingSheetBack: {
	nsClass: "GXPainter",
	gxFillColor: "BackColor2",
},

})
